# Disable debug rpm on EPEL/CentOS Stream
%global debug_package %{nil}

# https://github.com/xperimental/nextcloud-exporter
%global goipath         github.com/xperimental/nextcloud-exporter
Version:                0.6.2

%global user        nextcloud-exporter
%global group       nobody

%gometa

%global common_description %{expand:
A prometheus exporter for getting some metrics of a nextcloud server instance.}

%global golicenses      LICENSE


Name:               nextcloud-exporter
Release:            1%{?dist}
Summary:            Prometheus exporter for Nextcloud servers
URL:                %{gourl}
License:            MIT

Source0:            %{gosource}
Source1:            https://github.com/xperimental/%{name}/raw/master/contrib/%{name}.service
Source2:            %{name}.yml

Requires(post):     systemd
Requires(preun):    systemd
Requires(postun):   systemd


%description
%{common_description}

#%%gopkg

%prep
%autosetup


%build
go mod vendor
CGO_ENABLED=0 go build -buildmode pie -compiler gc '-tags=rpm_crashtraceback' -ldflags '-X %{goipath}/version=%{version} -compressdwarf=false -s -w' -o %{gobuilddir}/bin/%{name} %{goipath}


%install
install -D -p -m 0755 %{gobuilddir}/bin/%{name} %{buildroot}%{_bindir}/%{name}
install -D -p -m 0644 %{SOURCE1} %{buildroot}%{_prefix}/lib/systemd/system/%{name}.service
sed -e 's/^Group=.*/Group=%{group}/g' -i %{buildroot}%{_prefix}/lib/systemd/system/%{name}.service
install -D -p -m 0644 %{SOURCE2} %{buildroot}%{_sysconfdir}/%{name}.yml

%pre
getent passwd %{user} >/dev/null || \
    useradd -r -s /sbin/nologin -d / -M \
    -c "Exporter for Nextcloud metrics" -g %{group} %{user}
exit 0

%post
%systemd_post %{name}.service

%preun
%systemd_preun %{name}.service

%postun
%systemd_postun_with_restart %{name}.service

%files
%license LICENSE
%doc README.md
%{_bindir}/%{name}
%{_prefix}/lib/systemd/system/%{name}.service
%attr(0640,%{user},root) %config(noreplace) %{_sysconfdir}/%{name}.yml
